package com.bergerkiller.bukkit.nolagg.sending;

import java.util.Collection;

import net.minecraft.server.Chunk;
import net.minecraft.server.ChunkCoordIntPair;
import net.minecraft.server.EntityPlayer;
import net.minecraft.server.Packet;
import net.minecraft.server.Packet51MapChunk;
import net.minecraft.server.Packet53BlockChange;
import net.minecraft.server.TileEntity;
import net.minecraft.server.World;

import org.bukkit.block.BlockFace;

public class SendPendingChunk extends ChunkCoordIntPair implements Comparable<SendPendingChunk> {
	private int index;
	private Chunk chunk;
	private Packet51MapChunk packet;
	public SendPendingChunk(final int x, final int z) {
		super(x, z);
	}
	public void calculateIndex(final int midx, final int midz, final BlockFace direction) {
		this.index = ChunkCoordIndexer.get(this.x - midx, this.z - midz, direction);
	}
	public int compareTo(SendPendingChunk ipair) {
		return this.index - ipair.index;
	}
	public boolean loadChunk(World world) {
		if (this.chunk == null) return false;
		this.chunk = world.getChunkAt(this.x, this.z);
		return true;
	}
	public Chunk getChunk() {
		return this.chunk;
	}
	public boolean hasPacket() {
		return this.packet != null;
	}
	public void loadPacket(Packet51MapChunk packet) {
		this.packet = packet;
	}

    public void send(final EntityPlayer receiver) {
    	send(receiver, this.packet, this.chunk);
    }    
    @SuppressWarnings("unchecked")
	public static void send(final EntityPlayer receiver, final Packet51MapChunk mapPacket, final Chunk chunk) {
    	receiver.netServerHandler.sendPacket(mapPacket);
    	Packet p;
    	for (TileEntity tile : (Collection<TileEntity>) chunk.tileEntities.values()) {
    		if ((p = tile.k()) != null) {
    			receiver.netServerHandler.sendPacket(p);
    		}
    	}
    	//send trigger
    	receiver.netServerHandler.sendPacket(new Packet53BlockChange(chunk.x << 4, 0, chunk.x << 4, chunk.world));
    }
}
